"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/esm/asyncToGenerator"));

var _core = _interopRequireDefault(require("@arice/core"));

var _util = require("@arice/util");

var _constants = require("./constants");

var bootstrap = function bootstrap(_ref) {
  var _ref$framework = _ref.framework,
      framework = _ref$framework === void 0 ? {} : _ref$framework,
      _ref$apps = _ref.apps,
      apps = _ref$apps === void 0 ? {} : _ref$apps,
      _ref$plugins = _ref.plugins,
      plugins = _ref$plugins === void 0 ? [] : _ref$plugins,
      _ref$beforeBootstrap = _ref.beforeBootstrap,
      beforeBootstrap = _ref$beforeBootstrap === void 0 ? _constants.NOOP : _ref$beforeBootstrap,
      _ref$afterBootstrap = _ref.afterBootstrap,
      afterBootstrap = _ref$afterBootstrap === void 0 ? _constants.NOOP : _ref$afterBootstrap;
  return (
    /*#__PURE__*/
    function () {
      var _ref2 = (0, _asyncToGenerator2["default"])(
      /*#__PURE__*/
      _regenerator["default"].mark(function _callee(appName) {
        var rf, bb, ab, currentApp, bundlePromise, _currentApp$container, container, _currentApp$props, props, _currentApp$sideEffec, sideEffects, _currentApp$beforeBoo, _beforeBootstrap, _currentApp$afterBoot, _afterBootstrap, getBundle, app;

        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                rf = new _core["default"].Framework(framework);
                bb = beforeBootstrap, ab = afterBootstrap;

                if (!(appName in apps)) {
                  _context.next = 22;
                  break;
                }

                currentApp = apps[appName];
                bundlePromise = currentApp.bundle, _currentApp$container = currentApp.container, container = _currentApp$container === void 0 ? null : _currentApp$container, _currentApp$props = currentApp.props, props = _currentApp$props === void 0 ? {} : _currentApp$props, _currentApp$sideEffec = currentApp.sideEffects, sideEffects = _currentApp$sideEffec === void 0 ? _constants.NOOP : _currentApp$sideEffec, _currentApp$beforeBoo = currentApp.beforeBootstrap, _beforeBootstrap = _currentApp$beforeBoo === void 0 ? bb : _currentApp$beforeBoo, _currentApp$afterBoot = currentApp.afterBootstrap, _afterBootstrap = _currentApp$afterBoot === void 0 ? ab : _currentApp$afterBoot;

                getBundle = function getBundle() {
                  return null;
                };

                if (_util.internal.is.isFunction(bundlePromise)) {
                  getBundle = function getBundle() {
                    return bundlePromise().then(function (mod) {
                      return mod["default"];
                    });
                  };
                }

                _context.next = 9;
                return getBundle();

              case 9:
                app = _context.sent;

                if (app) {
                  _context.next = 12;
                  break;
                }

                throw new Error("Bundle of [".concat(appName, "] load failed, please check."));

              case 12:
                _context.next = 14;
                return _beforeBootstrap(rf, currentApp);

              case 14:
                _context.next = 16;
                return sideEffects(rf.$effectCenter.$effect);

              case 16:
                _context.next = 18;
                return rf.loadApp(app, container, props, plugins);

              case 18:
                _context.next = 20;
                return _afterBootstrap(rf, currentApp);

              case 20:
                _context.next = 23;
                break;

              case 22:
                throw new Error("Can not find this app: ".concat(appName, "."));

              case 23:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref2.apply(this, arguments);
      };
    }()
  );
};

var _default = bootstrap;
exports["default"] = _default;